<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('external_engagements', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('department_id');
            $table->unsignedBigInteger('faculty_id'); // Faculty who uploaded the publication

            $table->string('activity');
            $table->text('activity_description');
            $table->string('inviting_organization');
            $table->date('start_date');
            $table->date('end_date');
            $table->integer('num_days');
            $table->string('proof')->nullable(); // For file path

            // Foreign keys
            $table->foreign('department_id')->references('id')->on('departments')->onDelete('cascade');
            $table->foreign('faculty_id')->references('id')->on('users')->onDelete('cascade');

            // Indexes for better performance
            $table->index('department_id');
            $table->index('faculty_id');

            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('external_engagements');
    }
};
